
; BackBuffer flips between RAM banks 5 and 7
BackBuffer        equ   49152

ARROWTIMING       equ   2
MANTIMING         equ   2
EXPLOSIONTIMING   equ   2
FLOORTIMING       equ   4


                  org   32768
start             jp    progstart

                  ds    256

progstart:        di
                  ld    hl,#8000
                  ld    de,#8001
                  ld    bc,256
                  ld    a,h
                  ld    (hl),#7f
                  ldir
                  ld    i,a
                  im    2

                  ld    a,195
                  ld    hl,im2handler
                  ld    (#7f7f),a
                  ld    (#7f80),hl
                  ei

                  call  SetupTables
                  call  ResetPaging
                  ld    a,7
                  ld    (renderpage),a
                  call  MainMenu

                  halt
                  di

                  ld    bc,2700
nearint:          dec   bc
                  ld    a,b
                  or    c
                  jr    nz,nearint

                  ld    bc,#7ffd
                  ld    a,(23388)
                  out   (c),a
                  ld    a,#3f
                  ld    i,a
                  im    1
                  ld    iy,23610
                  ld    hl,#2758
                  exx
                  ei
                  ld    bc,0
                  ret


invadergfx:       incbin "invaders.sgf"

FlipScreen:       push  af
                  ld    a,(rampage)
                  xor   8                 ; flip screen bit
                  ld    (rampage),a

                  xor   a
                  call  PageRam		; effects the flipped screen

                  ld    a,(renderpage)
                  xor   2
                  ld    (renderpage),a
                  pop   af
                  ret

ResetPaging:      ld    a,16
                  ld    (rampage),a
                  xor   a                 ; continue into pageram

PageRam:          push  bc
                  push  de
                  and   7
                  ld    e,a
                  ld    bc,&7ffd
                  ld    a,(rampage)
                  and   248
                  or    e
                  ld    (rampage),a
                  out   (c),a
                  pop   de
                  pop   bc
                  ret

MainMenu:         ld    hl,(hiscore)
                  ld    de,menuhiscore
                  call  WordToString

                  ld    a,1
                  ld    (on_menu),a
                  ld    a,8
                  ld    (Level),a

                  call  InitAY
                  call  SetupInvaders

                  ld    ix,InvaderTable
                  ld    hl,menuinvsettab
                  ld    de,BYTESPERINVADER
                  ld    b,21
setmenuinv:       ld    a,(hl)
                  inc   hl
                  xor   1
                  ld    (ix+INV_DEAD),a
                  add   ix,de
                  djnz  setmenuinv

                  ld    hl,menuscrolltext
                  ld    (menutextptr),hl

waitenter:        call  ClearScreen

                  call  HandleInvaderBullets
                  call  plotstarfield
                  call  MoveInvaders
                  call  DrawInvaders

                  ld    de,menutext
                  call  WriteText

                  ld    de,menutext_1+1
                  ld    a,(de)
                  inc   a
                  and   7
                  ld    (de),a
                  dec   de
                  call  WriteText

                  halt
                  halt
                  ld    de,menuscrollinit
                  call  WriteText

                  ld    hl,(menutextptr)
DrawScrollTxt:    ld    a,(hl)
                  or    a
                  jr    nz,DrawScrollTxt1
                  ld    hl,menuscrolltext
                  ld    a,(hl)

DrawScrollTxt1:   inc   hl
                  ld    (menutextptr),hl

DrawScrollTxt2:   push  hl
                  call  WriteChar
                  pop   hl
                  ld    a,(textposn)
                  or    a
                  jr    z,DrawScrollExit
                  ld    a,(hl)
                  inc   hl
                  or    a
                  jr    nz,DrawScrollTxt2
                  ld    hl,menuscrolltext
                  ld    a,(hl)
                  jr    DrawScrollTxt2

DrawScrollExit:   call  FlipScreen

                  ld    a,#f7
                  in    a,(254)
                  and   24
                  ret   z			; exit if keys 4 and 5 pressed

                  ld    a,#bf
                  in    a,(254)
                  rra
                  ld    a,0
                  jr    nc,startgame

                  ld    a,#fe
                  in    a,(254)
                  and   8
                  jr    nz,waitenter

                  ld    a,1

startgame:        ld    (cheatmode),a
                  xor   a
                  ld    (on_menu),a
                  call  Game
                  jp    MainMenu

menutextptr       dw    0

menuinvsettab:    db    0,1,1,1,1,1,0
                  db    1,0,1,0,1,0,1
                  db    0,1,1,1,1,1,0

menuscrollinit:   db    C_AT, 22, 0
                  db    C_SINGLE
                  db    C_INK, 6
                  db    0

menuscrolltext:   db    "                                   "
                  db    "welcome to SUPER CRAP INVADERS (c) woody 2004.       "
                  db    "control miner willy using o for left, p for right, "
                  db    "space to jump and z to fire.       "
                  db    "beware the second rate clones such as "
                  db    "HYPER POO CREATURES (hi jim !).      "
                  db    "guide miner willy through endless waves of "
                  db    "the most pathetic looking aliens you've ever seen "
                  db    "in the history of computer gaming !"
                  db    0

menutext:         db    C_SINGLE
                  db    C_INK,6
                  db    C_AT, 4, 6
                  db    "starring miner willy"

                  db    C_INK, 6
                  db    C_AT, 15, 6
                  db    C_DOUBLE
                  db    "press", 8
                  db    C_INK, 2, "ENTER", C_INK, 6
                  db    8, "to", 8, "start"
                  db    C_SINGLE

                  db    C_INK,5
                  db    C_AT,19,8
                  db    "hiscore: "
                  db    C_INK,7
menuhiscore       db    "00000"
                  db    "0"
                  db    0

menutext_1:       db    C_INK, 5
                  db    C_AT, 1, 6
                  db    C_DOUBLE
                  db    "SUPER CRAP INVADERS"
                  db    C_SINGLE
                  db    0

ClearScreen:      xor   a
                  out   (254),a
                  ld    a,(renderpage)
                  call  PageRam
                  ld    a,#47
                  call  ClearBackBuffer
                  ld    a,71
                  ld    (textattr),a
                  ld    hl,0
                  ld    (textposn),hl
                  ret

;--------------------------------------------------------------------------------

Game:             xor   a
                  ld    (Level),a
                  ld    a,5
                  ld    (Lives),a
                  ld    hl,0
                  ld    (score),hl
                  ld    hl,100
                  ld    (nextextrascore),hl

                  ld    a,#47
                  ld    (backbuffercolour),a

startnewlevel:    call  ClearScreen

                  ld    hl,Level
                  ld    a,(hl)
                  inc   a
                  cp    100
                  jr    c,levok1
                  ld    a,1
levok1:           ld    (hl),a

                  ld    c,"0"-1
                  ld    hl,levelnumtx
getlvtx1:         inc   c
                  sub   10
                  jr    nc,getlvtx1

                  add   a,"0"+10
                  ld    (hl),c
                  inc   hl
                  ld    (hl),a

                  ld    de,leveltext
                  call  WriteText
                  call  FlipScreen

                  ld    b,50
                  call  WaitInts

                  call  SetupInvaders

restartlevel:     call  ClrScrollText

                  ld    a,(Lives)
                  cp    1
                  jr    nz,notlastman

                  ld    hl,Scroll_LastLife
                  call  SetScrollText
                  jr    restartmain

notlastman:       ld    a,(Level)
                  cp    9
                  jr    nz,restartmain

                  ld    hl,Scroll_DontFall
                  call  SetScrollText


restartmain:      call  InitAY

                  xor   a
                  ld    (mandead),a
                  ld    (manshot),a
                  ld    (manjumping),a
                  ld    (manmoved),a
                  ld    (IsArrow),a

                  ld    hl,#880f        ; man starts 136 pixels down, 15 chars across
                  ld    (manposn),hl

                  ld    a,h
                  add   a,16            ; floor is 16 pixels below man's start position
                  ld    h,a
                  ld    l,0
                  ld    (floorposn),hl

                  ld    a,1             ; start facing left
                  ld    (mandir),a
                  ld    a,3
                  ld    (manframe),a

                  ld    a,ARROWTIMING
                  ld    (ArrowTimer),a
                  ld    a,50
                  ld    (ArrowDelay),a

                  ld    a,MANTIMING
                  ld    (ManTimer),a

                  ld    a,(invadersalive)
                  or    a
                  rra
                  ld    (InvaderTimer),a

                  ld    a,EXPLOSIONTIMING
                  ld    (ExplosionTimer),a
                  call  ClearExplosion

                  ld    a,FLOORTIMING
                  ld    (FloorTimer),a
                  call  SetupFloor

                  call  ClearInvaderBullets

mainloop:         ld    a,(renderpage)
                  call  PageRam

                  ld    a,(backbuffercolour)
                  cp    #47
                  jr    z,gotbbcolr
                  sub   8
                  ld    (backbuffercolour),a
                  and   %00111000
                  or    7
gotbbcolr:        call  ClearBackBuffer

                  ; first we draw everything that kills your man on contact
                  ld    a,(ArrowTimer)
                  or    a
                  call  z,HandleArrows
                  ld    a,(IsArrow)
                  or    a
                  call  nz,DrawArrow

                  ld    a,(FloorTimer)
                  or    a
                  call  z,MoveFloorHole
                  call  DrawFloor

                  ld    a,(ManTimer)
                  or    a
                  call  z,MoveMan

                  call  HandleInvaderBullets

                  ; any pixel collision when drawing the miner willy sprite
                  ; sets the "mandead" var
                  call  DrawMan

                  call  plotstarfield

                  ld    a,(InvaderTimer)
                  or    a
                  call  z,MoveInvaders
                  ld    a,(invadersalive)
                  cp    1
                  call  z,MoveInvaders
                  call  DrawInvaders

                  call  HandleManShot

                  ld    a,(ExplosionTimer)
                  or    a
                  call  z,HandleExplosionParticles

                  call  WriteScore
                  call  DrawLives

                  call  MoveScrollText

                  call  FlipScreen

                  ld    a,(invlanded)
                  or    a
                  jp    nz,GameOver

                  ld    a,(mandead)
                  or    a
                  jp    nz,LostLife

                  ld    a,(invadersalive)
                  or    a
                  jp    z,startnewlevel

                  jp    mainloop


LostLife:         call  KillAY

                  ld    a,(renderpage)
                  xor   2
                  ld    (renderpage),a
                  call  PageRam

                  ld    a,#47
Fade1:            ld    hl,49152+6144
                  ld    de,49152+6145
                  ld    bc,767
                  ld    (hl),a
                  ldir

                  ld    e,a
                  cpl
                  and   7
                  rlca
                  rlca
                  rlca
                  or    7
                  ld    d,a
                  ld    c,e
                  rrc   c
                  rrc   c
                  rrc   c
                  xor   a
FNoise1:          out   (254),a
                  xor   24
                  ld    b,d
FNoise2:          djnz  FNoise2
                  dec   c
                  jr    nz,FNoise1
                  ld    a,e
                  dec   a
                  cp    #3f
                  jr    nz,Fade1

                  ld    a,(renderpage)
                  xor   2
                  ld    (renderpage),a
                  call  PageRam

                  ld    a,(cheatmode)
                  or    a
                  jp    nz,restartlevel

                  ld    hl,Lives
                  dec   (hl)
                  jp    z,GameOver
                  jp    restartlevel

GameOver:         call  KillAY

                  call  ClearScreen
                  ld    de,gotext1
                  call  WriteText
                  call  FlipScreen

                  ld    b,100
                  call  WaitInts

                  call  ClearScreen
                  ld    de,gotext1
                  call  WriteText

                  ld    de,gotext2
                  ld    b,100
                  ld    a,(invlanded)
                  or    a
                  jr    z,go_1
                  ld    de,landedtext
                  ld    b,200

go_1:             push  bc
                  call  WriteText
                  call  FlipScreen
                  pop   bc

WaitInts:         halt
                  djnz  WaitInts
                  ret

gotext1:          db    C_INK, 5
                  db    C_AT, 9, 11
                  db    C_DOUBLE
                  db    "GAME OVER"
                  db    C_SINGLE
                  db    0

gotext2:          db    C_INK,3
                  db    C_AT, 12, 10
                  db    C_DOUBLE
                  db    "you're shit!"
                  db    C_SINGLE
                  db    0

landedtext:       db    C_INK,3
                  db    C_AT, 12, 6
                  db    C_DOUBLE
                  db    "the invaders landed"
                  db    C_AT, 15, 6
                  db    "and they ate you !!"
                  db    C_SINGLE
                  db    0

leveltext:        db    C_INK,6
                  db    C_AT, 10, 12
                  db    C_DOUBLE
                  db    "level "
levelnumtx:       db    "00"
                  db    C_SINGLE
                  db    0

ArrowTimer        db    0
ManTimer          db    0
InvaderTimer      db    0
ExplosionTimer    db    0
FloorTimer        db    0

cheatmode         db    0
rampage           db    0
renderpage        db    0
Lives             db    0
Level             db    0
on_menu           db    0

                  include     "Misc.asm"
                  include	"Floor.asm"
                  include	"Man.asm"
                  include	"Invaders.asm"
                  include	"Arrows.asm"
                  include	"Explosion.asm"
                  include	"Sound.asm"
                  include	"Starfield.asm"
                  include	"Text.asm"
                  include	"ScrollText.asm"

                  end   start

