
manposn           dw    0
mandir            db    0
manframe          db    0
mandead           db    0
manshot           db    0
manshotposn       dw    0
manmoved          db    0
manjumping        db    0
manjumptableptr   dw    0

manjumptable      db    -8, -4, -4, -2, -2, -2, -1, -1, -1, -1, 0, 0
                  db    0, 0, 1, 1, 1, 1, 2, 2, 2, 4, 4, 8
                  db    128

;--------------------------------------------------------------------------------

MoveMan:          ld    a,MANTIMING
                  ld    (ManTimer),a

                  ld    a,(manjumping)
                  or    a
                  jp    nz,handlemanjump

                  xor   a
                  ld    (manmoved),a

                  ld    hl,(manposn)
                  ld    a,h
                  add   a,16
                  ld    h,a
                  call  MapScreenAddress
                  call  Scr2Attr
                  ld    a,(hl)
                  or    a
                  jp    nz,mannothole
                  inc   l
                  ld    a,(hl)
                  or    a
                  jp    z,maninhole

mannothole:       ld    a,#7f
                  in    a,(254)
                  and   1
                  jr    nz,nomanjump

                  ld    a,1
                  ld    (manjumping),a

                  ld    hl,manjumptable
                  ld    (manjumptableptr),hl

nomanjump:        ld    a,#df
                  in    a,(254)
                  and   3
                  ret   z     ; both O and P pressed
                  cp    3
                  ret   z     ; neither O nor P pressed

                  rra
                  jp    nc,manright

manleft:          ld    a,(mandir)
                  or    a
                  jr    nz,m_lf1    ; already facing left
            
                  ld    a,1
                  ld    (mandir),a
                  ret

m_lf1:            ld    a,1
                  ld    (manmoved),a
                  ld    a,(manframe)
                  or    a
                  jr    z,m_lf2
                  dec   a
                  ld    (manframe),a
                  ret

m_lf2:            ld    hl,(manposn)
                  ld    a,l
                  and   31
                  ret   z     ; at left edge
                  dec   l
                  ld    (manposn),hl
                  ld    a,3
                  ld    (manframe),a
                  ret

manright:         ld    a,(mandir)
                  or    a
                  jr    z,m_rt1     ; already facing right
            
                  xor   a
                  ld    (mandir),a
                  ret

m_rt1:            ld    a,1
                  ld    (manmoved),a
                  ld    a,(manframe)
                  cp    3
                  jr    z,m_rt2
                  inc   a
                  ld    (manframe),a
                  ret

m_rt2:            ld    hl,(manposn)
                  ld    a,l
                  and   31
                  cp    30
                  ret   z     ; at right edge
                  inc   l
                  ld    (manposn),hl
                  xor   a
                  ld    (manframe),a
                  ret

handlemanjump:    ld    hl,(manjumptableptr)
                  ld    a,(hl)
                  cp    128
                  jr    z,endmanjump
                  inc   hl
                  ld    (manjumptableptr),hl
                  ld    hl,(manposn)
                  add   a,h
                  ld    h,a
                  ld    (manposn),hl

                  ld    a,(manmoved)
                  or    a
                  ret   z
                  ld    a,(mandir)
                  or    a
                  jp    z,manright
                  jp    manleft

endmanjump:       xor a
                  ld (manjumping),a
                  ret

maninhole:        ld    a,1
                  ld    (mandead),a
                  ret

;--------------------------------------------------------------------------------

DrawMan:          ld    a,(mandir)  ; 0=right, 1=left
                  add   a,a
                  add   a,a
                  ld    l,a

                  ld    a,(manframe)      ; 0-3
                  add   a,l
                  ld    l,a
                  ld    h,0
                  add   hl,hl
                  add   hl,hl
                  add   hl,hl
                  add   hl,hl
                  add   hl,hl
                  ld    de,ManGfx
                  add   hl,de
                  ex    de,hl ; de=man gfx

                  ld    hl,(manposn)
                  call  MapScreenAddress

                  ld    bc,#1000  ; B=16, C=0
drawman_1:        ld    a,(de)
                  and   (hl)
                  or    c
                  ld    c,a
                  ld    a,(de)
                  or    (hl)
                  ld    (hl),a
                  inc   de
                  inc   l
                  ld    a,(de)
                  and   (hl)
                  or    c
                  ld    c,a
                  ld    a,(de)
                  or    (hl)
                  ld    (hl),a
                  inc   de
                  dec   l
                  call  NextPixelLine
                  djnz  drawman_1

                  ld    a,c
                  or    a
                  ret   z
                  ld    (mandead),a
                  ret

;--------------------------------------------------------------------------------

HandleManShot:    ld    a,(manshot)
                  or    a
                  jp    nz,HandleManBullet
            
                  ld    a,#fe
                  in    a,(254)
                  and   2
                  ret   nz
            
                  ld    c,%11000000
                  ld    hl,manbulletgfx
                  ld    a,(mandir)
                  or    a
                  ld    a,(manframe)
                  jr    z,gesgx0
                  xor   3
                  ld    b,a
                  ld    a,3
                  sub   b

gesgx0:           or    a
                  jr    z,gotshotgfx
gesgx1:           rr    c
                  rr    c
                  dec   a
                  jr    nz,gesgx1

gotshotgfx:       ld    b,8
gsgx1:            ld    (hl),c
                  inc   hl
                  djnz  gsgx1
            
                  ld    a,1
                  ld    (manshot),a
            
                  ld    hl,(manposn)
                  ld    (manshotposn),hl
                  ret

HandleManBullet:  ld    hl,(manshotposn)
                  ld    a,h
                  sub   8
                  ld    h,a
                  ld    (manshotposn),hl
                  jp    c,endmanshot

                  call  DrawManBullet
                  ret   z     ; bullet hit nothing

                  ld    hl,(manshotposn)
                  ld    ix,InvaderTable
                  ld    b,NUMINVADERS
bhit1:            ld    a,(ix+INV_DEAD)
                  or    a
                  jp    nz,bhnxt
                  ld    a,(ix+INV_X)
                  cp    l
                  jp    z,bhit2
                  inc   a
                  cp    l
                  jp    z,bhit2
                  inc   a
                  cp    l
                  jp    nz,bhnxt
bhit2:            ld    a,(ix+INV_Y)
                  cp    h
                  jp    nc,bhnxt
                  add   a,16
                  cp    h
                  jp    nc,invaderhit

bhnxt:            ld    de,BYTESPERINVADER
                  add   ix,de
                  dec   b
                  jp    nz,bhit1
                  ret

invaderhit:       xor   a
                  ld    (manshot),a
                  ld    (ix+INV_DEAD),1

                  call  SetExplosionLocation    ; bullet posn becomes new explosion posn
                  call  SetExplosionSound

                  ld    hl,invadersalive
                  dec   (hl)                     ; one less living invader

                  ld    b,0
                  ld    c,(ix+INV_SCORE)
                  jp    AddScore

endmanshot:       xor   a
                  ld    (manshot),a
                  ret


DrawManBullet:    ld    hl,(manshotposn)
                  call  MapScreenAddress
                  ld    de,manbulletgfx
                  ld    bc,#0800
drwmb1:           ld    a,(de)
                  and   (hl)
                  jp    z,bhitnowt
                  ld    c,1
bhitnowt:         ld    a,(de)
                  or    (hl)
                  ld    (hl),a
                  inc   de
                  call  NextPixelLine
                  dec   b
                  jp    nz,drwmb1
                  bit   0,c
                  ret

manbulletgfx:     db    %00011000
                  db    %00011000
                  db    %00011000
                  db    %00011000
                  db    %00011000
                  db    %00011000
                  db    %00111100
                  db    %00111100

;--------------------------------------------------------------------------------

ManGfx:           db    60,0,60,0,126,0,52,0,62,0,60,0,24,0,60,0
                  db    126,0,126,0,247,0,251,0,60,0,118,0,110,0,119,0
                  db    15,0,15,0,31,128,13,0,15,128,15,0,6,0,15,0
                  db    27,128,27,128,27,128,29,128,15,0,6,0,6,0,7,0
                  db    3,192,3,192,7,224,3,64,3,224,3,192,1,128,3,192
                  db    7,224,7,224,15,112,15,176,3,192,7,96,6,224,7,112
                  db    0,240,0,240,1,248,0,208,0,248,0,240,0,96,0,240
                  db    1,248,3,252,7,254,6,246,0,248,1,218,3,14,3,140
                  db    15,0,15,0,31,128,11,0,31,0,15,0,6,0,15,0
                  db    31,128,63,192,127,224,111,96,31,0,91,128,112,192,49,192
                  db    3,192,3,192,7,224,2,192,7,192,3,192,1,128,3,192
                  db    7,224,7,224,14,240,13,240,3,192,6,224,7,96,14,224
                  db    0,240,0,240,1,248,0,176,1,240,0,240,0,96,0,240
                  db    1,216,1,216,1,216,1,184,0,240,0,96,0,96,0,224
                  db    0,60,0,60,0,126,0,44,0,124,0,60,0,24,0,60
                  db    0,126,0,126,0,239,0,223,0,60,0,110,0,118,0,238
