
scrtable:         ds    192*2

SetupTables:      ld    ix,scrtable
                  ld    hl,BackBuffer
                  ld    b,192
setst1:           ld    (ix+0),l
                  ld    (ix+1),h
                  call  NextPixelLine
                  inc   ix
                  inc   ix
                  djnz  setst1
                  ret

NextPixelLine:    inc   h
                  ld    a,h
                  and   7
                  ret   nz
                  ld    a,h
                  sub   8
                  ld    h,a
NextPixelLn_1:    ld    a,l
                  add   a,32
                  ld    l,a
                  and   224
                  ret   nz
                  ld    a,h
                  add   a,8
                  ld    h,a
                  ret

; entry H = pixels down, L = chars across
; exit  HL = display address
MapScreenAddress: push  de
                  ld    a,l
                  ld    l,h
                  ld    h,0
                  add   hl,hl
                  ld    de,scrtable
                  add   hl,de
                  add   a,(hl)
                  inc   hl
                  ld    h,(hl)
                  ld    l,a
                  pop   de
                  ret

; entry HL = display address
; exit  HL = attr address
Scr2Attr:         ld    a,h
                  rrca
                  rrca
                  rrca
                  and   3
                  or    &d8
                  ld    h,a
                  ret

; A = attribute colour for backbuffer
ClearBackBuffer:  ld    (oldsp+1),sp
                  ld    sp,BackBuffer+6912
                  ld    h,a
                  ld    l,a
                  ld    b,24
ClrAttrs:         db    229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229
                  djnz  ClrAttrs

                  ld    hl,0
                  ld    b,192
ClrDisplay:       db    229,229,229,229,229,229,229,229,229,229,229,229,229,229,229,229
                  djnz  ClrDisplay

oldsp:            ld    sp,0
                  ret

CopyBackBuffer:   di
                  ld    hl,BackBuffer
                  ld    de,16384
                  ld    b,192+24
CopyBack:         db    #ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0
                  db    #ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0
                  db    #ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0
                  db    #ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0,#ED,#A0
                  djnz  CopyBack
                  ei
                  ret

im2handler:       push  hl
                  push  bc
                  push  af

                  ld    hl,ArrowTimer
                  ld    b,5               ; number of timers
DecTimers:        ld    a,(hl)
                  or    a
                  jr    z,timerzero
                  dec   (hl)

timerzero:        inc   hl
                  djnz  DecTimers

                  ld    bc,#fffd
                  ld    a,9
                  out   (c),a
                  in    a,(c)
                  or    a
                  jr    z,noexpdecay
                  dec   a
                  ld    b,#bf
                  out   (c),a

noexpdecay:       pop   af
                  pop   bc
                  pop   hl
                  ei
                  ret

; BC = value to add to score
AddScore:         push  hl
                  push  de
                  ld    hl,(score)
                  add   hl,bc
                  ld    (score),hl
                  ld    de,(hiscore)
                  or    a
                  sbc   hl,de
                  jr    c,addsc_1
                  add   hl,de
                  ld    (hiscore),hl

addsc_1:          ld    hl,(score)
                  ld    de,(nextextrascore)
                  or    a
                  sbc   hl,de
                  jr    c,addscexit
                  ex    de,hl
                  ld    de,100
                  add   hl,de
                  ld    (nextextrascore),hl

                  ld    hl,Lives
                  inc   (hl)

                  ld    a,#47+56
                  ld    (backbuffercolour),a

                  ld    hl,Scroll_ExtraLife
                  call  SetScrollText

addscexit:        pop   de
                  pop   hl
                  ret

DrawLives:        ld    a,(Lives)
                  sub   1
                  ret   c
                  ret   z
                  and   31          ; restrict to 31 men
                  ld    c,a         ; number of men to draw
                  ld    a,32
                  sub   c
                  ld    l,a
                  ld    h,23*8
                  call  MapScreenAddress

DrawLives1:       push  hl
                  push  hl

                  ld    de,LivesGfx
                  ld    b,8
DrawLives2:       ld    a,(de)
                  ld    (hl),a
                  inc   de
                  inc   h
                  djnz  DrawLives2

                  pop   hl
                  call  Scr2Attr
                  ld    (hl),66

                  pop   hl
                  inc   l
                  dec   c
                  jp    nz,DrawLives1
                  ret

LivesGfx:         db    %00011000
                  db    %00111100
                  db    %01011010
                  db    %01111110
                  db    %01011010
                  db    %01100110
                  db    %00111100
                  db    %00011000

score             dw    0
hiscore           dw    0
nextextrascore    dw    0

backbuffercolour  db    0

;GameFont:         incbin      "Game.font"
GameFont:         incbin      "NewFont.font"


