
IsArrow           db    0
ArrowPosn         dw    0
ArrowDir          db    0
ArrowDelay        db    0     ; prevents arrow at start of levels

ARROWLEFT         equ   0
ARROWRIGHT        equ   1

HandleArrows:     ld    a,ARROWTIMING
                  ld    (ArrowTimer),a

                  ld    a,(ArrowDelay)
                  or    a
                  jr    z,arrowdelayup
                  dec   a
                  ld    (ArrowDelay),a
                  ret

arrowdelayup:     ld    a,(IsArrow)
                  or    a
                  jp    nz,DoArrow

                  ld    a,r
                  and   127
                  cp    7
                  ret   nc

                  cp    4
                  jr    nc,setarrowright

                  ld    a,ARROWLEFT
                  ld    hl,(manposn)
                  ld    l,31
                  jp    arrowcont

setarrowright:    ld    a,ARROWRIGHT
                  ld    hl,(manposn)
                  ld    l,0

arrowcont:        ld    (ArrowPosn),hl
                  ld    (ArrowDir),a
                  ld    a,1
                  ld    (IsArrow),a

                  ld    bc,#0280
                  xor   a
arrowbeep1:       out   (254),a
                  xor   24
arrowbeep2:       djnz  arrowbeep2
                  ld    b,c
                  dec   c
                  jr    nz,arrowbeep1

                  ld    a,3
                  ld    (ArrowDelay),a
                  ret

;--------------------------------------------------------------------------------

DoArrow:          ld    hl,(ArrowPosn)
                  ld    a,(ArrowDir)
                  cp    ARROWRIGHT
                  jr    z,movearrowright

movearrowleft:    ld    a,l
                  or    a
                  jr    z,terminatearrow

                  dec   l
                  ld    (ArrowPosn),hl
                  ret

movearrowright:   ld    a,l
                  cp    31
                  jr    z,terminatearrow

                  inc   l
                  ld    (ArrowPosn),hl
                  ret

terminatearrow:   xor   a
                  ld    (IsArrow),a
                  ret

;--------------------------------------------------------------------------------

DrawArrow:        ld    hl,(ArrowPosn)
                  call MapScreenAddress

                  ld    de,LeftArrowGfx
                  ld    a,(ArrowDir)
                  cp    ARROWLEFT
                  jp    z,DrawArrow_1
                  ld    de,RightArrowGfx

DrawArrow_1:      ld    b,8

DrawArrow_2:      ld    a,(de)
                  ld    (hl),a
                  inc   de
                  call  NextPixelLine
                  djnz  DrawArrow_2
                  ret

LeftArrowGfx:     db    0
                  db    %00011100
                  db    %01100000
                  db    %11111111
                  db    %11111111
                  db    %01100000
                  db    %00011100
                  db    0

RightArrowGfx:    db    0
                  db    %00111000
                  db    %00000110
                  db    %11111111
                  db    %11111111
                  db    %00000110
                  db    %00111000
                  db    0

